/* $Id: inet_acct.h,v 1.4 1994/09/10 20:40:42 root Exp $
 *
 * Copyright (C) 1994 Lars Fenneberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _LINUX_INET_ACCT_H
#define _LINUX_INET_ACCT_H

#include <linux/socket.h>

#define IPACCT_VERSION		"IPAcct v0.4, (c) Copyright 1994, Lars Fenneberg\n"

#define DEFAULT_WEIGHT		1

/* see also linux/sockios.h for future collisions */

#define SIOCADDWT	0x8980		/* Add weight entry */
#define SIOCDELWT	0x8981		/* Del weight entry */

struct ipacct_weight_entry {

	unsigned long addr;
	unsigned long mask;
	int	weight;
	
};

#ifdef __KERNEL__

#define USER_HASHMAX		247
#define USER_HASHVAL(i)		((i)&(USER_HASHMAX-1))

#define USER_MAGIC		0x4701
#define WEIGHT_MAGIC		0x4702

struct ipacct_user_s {

	int magic;

	uid_t	uid;	/* user who owns the socket     */
	int	sent;	/* bytes sent for this user     */
	int 	recv;	/* bytes received for this user */

	struct ipacct_user_s *succ;

};

struct  ipacct_weight_s {

	int magic;
	
	unsigned long addr;
	unsigned long mask;
	int	weight;			/* Weight of this address */
					/* (0 means ignore)       */ 

	struct ipacct_weight_s *succ;
	
};

int ipacct_sent(uid_t user, unsigned long daddr, int sent);
int ipacct_received(uid_t user, unsigned long daddr, int recv);
int ipacct_get_user_info(char *buffer, char **start, off_t offset, int length);
int ipacct_get_weight_info(char *buffer, char **start, off_t offset, int length);
int ipacct_ioctl(unsigned int cmd, void *arg);
void ipacct_init(void);

#endif /* __KERNEL__ */
#endif /* _LINUX_INET_ACCT_H */